//
// Are you Swift Ninja?
// Challenge Solutions 1-8
//

import Cocoa

//
// Solution #1
//

func swap<T>(inout a:T, inout with b:T) {
  (a, b) = (b, a)
}

//demo code
var a = "Marin", b = "Todorov"
swap(&a, &b)

[a, b] //--> ["Todorov", "Marin"]

//
// Solution #2
//

func flexStrings(s1: String = "", s2: String = "") -> String {
  return s1 + s2 == "" ? "none": s1 + s2
}

flexStrings() //--> "none"
flexStrings(s1: "One") //--> "One"
flexStrings(s1: "One", s2: " Two") //--> "One Two"

//
// Solution #3
//

func sumAny(anys: Any...) -> String {
  return String((anys.map({item in
    switch item {
    case "" as String, 0 as Int:
      return -10
    case let s as String where s.toInt() > 0:
      return s.toInt()!
    case is Int:
      return item as Int
    default:
      return 0
    }
    }) as [Int]).reduce(0) {
      $0 + $1
    })
}

let resultEmpty = sumAny() //--> "0"
let result1 = sumAny(NSObject(), 10, "-10", 2) //--> "12"
let result2 = sumAny("Marin Todorov", 2, 22, "-3", "10", "", 0, 33, -5) //--> "42"

//
// Solution #4
//

func countFrom(from: Int, #to: Int) {
  print(from)
  if from < to {
    countFrom(from + 1, to: to)
  }
}

countFrom(1, to: 5) //--> outputs to Assistant editor "12345"

println()

//to view the output click View > Assistant Editor > Show Assistant Editor

//
// Solution #5
//

func reverseString (input: String, output: String="") -> String {
  if input.isEmpty {
    return output
  } else {
    return reverseString(
      input.substringToIndex(input.endIndex.predecessor()),
      output: output + input.substringFromIndex(input.endIndex.predecessor()))
  }
}

reverseString("Marin Todorov") //--> "vorodoT niraM"

//
// Solution #6
//

func charMult(char: Character, var result: String, length: Double) -> String {
  if Int64(countElements(result)) < Int64(length) {
    result.append(char)
    return charMult(char, result, length)
  } else {
    return result
  }
}

func * (left: Character, right: Double) -> String {
  return charMult(left, "", right)
}

"-" * 10 + ">" //prints an arrow
"%" + "~" * 6  //prints a worm
"Z" * 20       //gets sleeping

//
// Solution #7
//

func doWork() -> Bool {
  return arc4random() % 10 > 5
}

func reportSuccess() -> Bool {
  println("success!")
  return true
}

func reportError() -> Bool {
  println("error")
  return true
}

doWork() && reportSuccess() || reportError()

//
// Solution #8
//

extension Array {
  func swapElementAtIndex(index: Int) -> (Int) -> Array {
    return { withIndex in
      var result = self
      if index < self.count && withIndex < self.count {
        (result[index], result[withIndex]) = (result[withIndex], result[index])
      }
      return result
    }
  }
  
  var arrayWithElementAtIndexToFront: (Int) -> Array {
    return swapElementAtIndex(0 as Int)
  }
  
  var arrayWithElementAtIndexToBack: (Int) -> Array {
    return swapElementAtIndex((self.count-1) as Int)
  }
}

let list = [1, 4, 5, 6, 20, 50] //--> [1, 4, 5, 6, 20, 50]

list.arrayWithElementAtIndexToBack(2) //--> [1, 4, 50, 6, 20, 5]

list.arrayWithElementAtIndexToFront(4) //--> [20, 4, 5, 6, 1, 50]

//
// Solution #9
// Did you solve Solution #9? Post your solution in the post comments!
//
